var state = new State;

function onControl(me, eventInfo)
{
    if (1 == parseInt(page.getWidget("masterButton").value)) {
        var newValue = !page.getWidget("masterOnIcon").visible;
        var ex = project.getTag('currentExtruder', state);
        // toggle value of masterTemp
        project.setTag('e' + ex + '_t', newValue);
        // force button release
        project.setTag('ctrlRequestTemp', 0);
    }
    
    return false; 
}


var simStep=0;

function simulation()
{
    // adjust setpoint every 10 steps
    simStep = (simStep + 1) %10;
    // Setup temperature pages
    for(var e=0; e<2; e++) {
        var SP = project.getTag('e' + e + '_sp', state, -1);
        var PV = project.getTag('e' + e + '_pv', state, -1);
        var S = project.getTag('e' + e + '_s', state, -1);
        var tOn = project.getTag('e' + e + '_t', state);
        var pv = [];
        var sp = [];
        var pp = [];
        var a = [];
        var lo = [];
        var hi = [];
        for(var i=0; i<12; i++) {
            if (tOn && S[i]) { // general switch + local switch must be on
                var s = SP[i];
                // Change setpoint every 10 steps
                if (simStep == 9) {
                    s = 150 * Math.random();
                }
                
                var r = Math.random();
                var p  = PV[i]; // prev value
                var step = (s-PV[i])/2 + 3*(r-0.5); /* noise */
                if (step != 0) {
                    p = Math.max(0, p + step*(r<0.7) + (step/2)*(r>0.7));
                }
                
                
                pv[i] = p;
                sp[i] = s;
                if (p > (s + 20))
                    hi[i] = true;
                else hi[i] = false;
                if (p < (s-20))
                    lo[i] = true;
                else lo[i] = false;
                pp[i] = 100 * Math.random();
                a[i] = 45 * Math.random();
            } else {
                pv[i] = 0;
                sp[i] = SP[i]; // preserve the setpoints
                pp[i] = 0;
                a[i] = 0;
                hi[i] = 0;
                lo[i] = 0;
            }
        }
        project.setTag('e' + e + '_pv', pv, -1);
        project.setTag('e' + e + '_sp', sp, -1);
        project.setTag('e' + e + '_pp', pp, -1);
        project.setTag('e' + e + '_a', a, -1);
        project.setTag('e' + e + '_hi', hi, -1);
        project.setTag('e' + e + '_lo', lo, -1);
    }
    
}

simulation();
// start simulation
page.setInterval(function() { simulation(); }, 1000);
